# Correctness checks:

fr <- list(a=9,b=89)
class(fr) <- "fred"
"$.fred" <- function (x,e) paste(x[[1]],e)

print(fr$a)
print(fr$"b")

f <- function(...) c(...$"a", ...$b)
print(f(fr))
print(f(list(x=0,a=99,b=77)))

# Timing tests:

source("time.r")

vl <- list (dd=1.4, cc=1.3, bb=1.2, aa=1.1)

pl <- pairlist (dd=1.4, cc=1.3, bb=1.2, aa=1.1)

ev <- new.env(parent=emptyenv())
ev$aa <- 1.1
ev$bb <- 1.2
ev$cc <- 1.3
ev$dd <- 1.4

n <- 3000000

cat("Access by exact name:\n")

sys.time({for (i in 1:n) s <- vl$aa+vl$bb+vl$cc+vl$dd})
print(s)

sys.time({for (i in 1:n) s <- pl$aa+pl$bb+pl$cc+pl$dd})
print(s)

sys.time({for (i in 1:n) s <- ev$aa+ev$bb+ev$cc+ev$dd})
print(s)

cat("\nAccess by exact string:\n")

sys.time({for (i in 1:n) s <- vl$"aa"+vl$"bb"+vl$"cc"+vl$"dd"})
print(s)

sys.time({for (i in 1:n) s <- pl$"aa"+pl$"bb"+pl$"cc"+pl$"dd"})
print(s)

sys.time({for (i in 1:n) s <- ev$"aa"+ev$"bb"+ev$"cc"+ev$"dd"})
print(s)

cat("\nAccess by partial name:\n")

sys.time({for (i in 1:n) s <- vl$a+vl$b+vl$c+vl$d})
print(s)

sys.time({for (i in 1:n) s <- pl$a+pl$b+pl$c+pl$d})
print(s)

cat("\nAccess by partial string:\n")

sys.time({for (i in 1:n) s <- vl$"a"+vl$"b"+vl$"c"+vl$"d"})
print(s)

sys.time({for (i in 1:n) s <- pl$"a"+pl$"b"+pl$"c"+pl$"d"})
print(s)
