source("time.r")

u <- seq(0,1,length=1000)
v <- seq(0,2,length=1000)

A2 <- matrix(2.1,2,1000)
A5 <- matrix(2.1,5,1000)
B3 <- matrix(3.2,1000,3)

A10 <- matrix(2.1,10,100)
B10 <- matrix(3.2,100,10)
B11 <- matrix(3.2,100,11)

A50 <- matrix(2.2,50,1000)

cat("vector-vector product, length 1000:\n")
sys.time ({for (i in 1:500000) w <- u %*% v})

cat("matrix-vector product, 5x1000 times 1000x1:\n")
sys.time ({for (i in 1:100000) w <- A5 %*% v})

cat("matrix-vector product, 50x1000 times 1000x1:\n")
sys.time ({for (i in 1:10000)  w <- A50 %*% v})

cat("matrix-matrix product, 2x1000 times 1000x3:\n")
sys.time ({for (i in 1:100000) R <- A2 %*% B3})

cat("matrix-matrix product, 5x1000 times 1000x3:\n")
sys.time ({for (i in 1:100000) R <- A5 %*% B3})

cat("matrix-matrix product, 10x1000 times 1000x10:\n")
sys.time ({for (i in 1:300000) R <- A10 %*% B10})

cat("matrix-matrix product, 10x1000 times 1000x11:\n")
sys.time ({for (i in 1:300000) R <- A10 %*% B11})
