# Correctness checks:

a <- c(aa=10,bb=20,cc=30,dd=40)
print(a[c(2,0,5,1)])
print(a[-2])
print(a[c("cc","aa","cc","ee")])

a[c("aa","ee")] <- c(100,500)
print(a)

M <- matrix(1:15,3,5)
print(M[c(2,NA,1,1),c(5,2,NA,5,3,NA)])

M[2:3,1:2] <- 999
print(M)

# Timing tests:

source("time.r")

cat("\nVectors indexed by scalars:\n\n")

a <- seq(0,1,length=200)
r <- 2.1

sys.time({ for (i in 1:2000000) b <- a[1] + a[r] + a[3] })
print(b)

sys.time({ for (i in 1:2000000) a[r] <- a[1] + a[3] })
print(a[r])

cat("\nVectors indexed by vectors:\n\n")

a <- seq(0,1,length=200)
x <- seq(1,100)
y <- seq(1,200,by=2)
z <- seq(1,200,by=2) + 0.1

sys.time({ for (i in 1:5000000) b <- a[10:12] + a[110:112] })
print(sum(b))

sys.time({ for (i in 1:1000000) b <- a[1:100] + a[101:200] })
print(sum(b))

sys.time({ for (i in 1:1000000) b <- a[x] + a[51:150] })
print(sum(b))

sys.time({ for (i in 1:1000000) b <- a[y] + a[51:150] })
print(sum(b))

sys.time({ for (i in 1:1000000) b <- a[z] + a[51:150] })
print(sum(b))

sys.time({ for (i in 1:1000000) b <- a[-1] + a[-100] })
print(sum(b))

sys.time({ for (i in 1:1000000) a[101:150] <- a[1:50] })
print(sum(a))

cat("\nMatrices indexed by scalars:\n\n")

A <- matrix(seq(0,1,length=150000),300,500)
r <- 2.1

sys.time({ for (i in 1:2000000) b <- A[3,4] + A[r,10] })
print(b)

sys.time({ for (i in 1:2000000) A[3,4] <- A[r,10] })
print(A[3,4])

cat("\nMatrices indexed by vectors:\n\n")

A <- matrix(seq(0,1,length=150000),300,500)

sys.time({ for (i in 1:50000) B <- A[100:200,300:400] })
print(c(sum(B),sum(B[10,]),sum(B[,10])))

sys.time({ for (i in 1:2000000) v <- A[10,300:400] })
print(c(sum(v),sum(exp(v))))

sys.time({ for (i in 1:2000000) v <- A[100:200,10] })
print(c(sum(v),sum(exp(v))))

sys.time({ for (i in 1:100000) A[101:130,301:400] <- 99 })
print(sum(A))
